﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace UsingWF
{
	public sealed partial class Workflow1: SequentialWorkflowActivity
	{
        internal Random rnd;

        internal bool m_isDsReviewOk;
        internal bool m_isDdOk;
        internal bool m_isMtOk;

		public Workflow1()
		{
			InitializeComponent();

            rnd = new Random();

            m_isDsReviewOk = false;
            m_isMtOk = false;
		}

        internal void DoSomething(string Name)
        {
            Console.Write(Name);
            Console.Write(" ");
            for (int i = 1; i <= 3; i++)
            {
                Console.Write(".");
                System.Threading.Thread.Sleep(1000);
            }
            Console.WriteLine("");
        }

        internal bool GetRandomBoolean()
        {
            double d = rnd.NextDouble();
            double result = Math.Round(d, 0);
            return result > 0;
        }

        private void DS_ExecuteCode(object sender, EventArgs e)
        {
            DoSomething("Now Details Specification is wirting");
            m_isDsReviewOk = false;
        }

        private void IsDsReviewNg(object sender, ConditionalEventArgs e)
        {
            e.Result = !m_isDsReviewOk;
        }

        private void DSReview_ExecuteCode(object sender, EventArgs e)
        {
            DoSomething("Now Details Specification is reviewing");
            m_isDsReviewOk = GetRandomBoolean();
            if (m_isDsReviewOk == true)
                Console.WriteLine("Details Specification review is OK.");
            else
                Console.WriteLine("Details Specification review is NG.");
        }

        private void Coding_ExecuteCode(object sender, EventArgs e)
        {
            DoSomething("Now is coding");
        }

        private void getIsNeedDD(object sender, ConditionalEventArgs e)
        {
            Console.Write("Need to Desk Debug for this project?(y/n)");
            ConsoleKeyInfo key = Console.ReadKey();
            Console.WriteLine("");
            e.Result = (key.Key == ConsoleKey.Y);
        }

        private void DD_ExecuteCode(object sender, EventArgs e)
        {
            DoSomething("Now the source code is being Desk Debugged by yourself");
            m_isDdOk = GetRandomBoolean();
            if (m_isDdOk == true)
                Console.WriteLine("Desk Debug is OK.");
            else
                Console.WriteLine("Desk Debug is NG.");
        }

        private void getIsDdNg(object sender, ConditionalEventArgs e)
        {
            e.Result = !m_isDdOk;
        }

        private void getIsMtNg(object sender, ConditionalEventArgs e)
        {
            e.Result = !m_isMtOk;
        }

        private void MT_ExecuteCode(object sender, EventArgs e)
        {
            DoSomething("Now you are running the unit test procedure");
            m_isMtOk = GetRandomBoolean();
            if (m_isMtOk == true)
                Console.WriteLine("Unit Test is OK.");
            else
                Console.WriteLine("Unit Test is NG.");
        }
    }

}
